Index: src/edu/ucsb/nceas/metacat/MetacatReplication.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetacatReplication.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/MetacatReplication.java	(revision 4080)
@@ -26,17 +26,25 @@
 
 package edu.ucsb.nceas.metacat;
 
-import edu.ucsb.nceas.dbadapter.AbstractDatabase;
 import java.util.*;
 import java.util.Date;
 import java.io.*;
 import java.sql.*;
 import java.net.*;
-import java.lang.*;
 import java.text.*;
+
 import javax.servlet.*;
 import javax.servlet.http.*;
 
+import edu.ucsb.nceas.dbadapter.AbstractDatabase;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.service.SessionService;
+import edu.ucsb.nceas.metacat.util.LDAPUtil;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.metacat.util.SessionData;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 import org.apache.log4j.Logger;
 import org.xml.sax.*;
 
@@ -46,7 +54,6 @@
   private Date firstTime;
   private boolean timedReplicationIsOn = false;
   Timer replicationDaemon;
-  private static MetaCatUtil util = new MetaCatUtil();
   private Vector fileLocks = new Vector();
   private Thread lockThread = null;
   private static final AbstractDatabase dbAdapter = MetaCatUtil.dbAdapter;
@@ -64,18 +71,17 @@
   public void init(ServletConfig config) throws ServletException
   {
      //initialize db connections to handle any update requests
-    MetaCatUtil util = new MetaCatUtil();
-    //deltaT = util.getOption("deltaT");
+    //deltaT = util.getProperty("deltaT");
     //the default deltaT can be set from metacat.properties
     //create a thread to do the delta-T check but don't execute it yet
     replicationDaemon = new Timer(true);
     try
     {
-       timedReplicationIsOn = (new Boolean(util.getOption(TIMEREPLICATION ).trim())).booleanValue();
+       timedReplicationIsOn = (new Boolean(PropertyService.getProperty(TIMEREPLICATION ).trim())).booleanValue();
        logMetacat.info("The timed replication on is"+timedReplicationIsOn);
-       timeInterval = (new Long(util.getOption(TIMEREPLICATIONINTERVAl).trim())).longValue();
+       timeInterval = (new Long(PropertyService.getProperty(TIMEREPLICATIONINTERVAl).trim())).longValue();
        logMetacat.warn("The timed replication time Inerval is "+ timeInterval);
-       String firstTimeStr = util.getOption(FIRSTTIME);
+       String firstTimeStr = PropertyService.getProperty(FIRSTTIME);
        logMetacat.warn("first replication time form property is "+firstTimeStr);
        firstTime = ReplicationHandler.combinateCurrentDateAndGivenTime(firstTimeStr);
        logMetacat.warn("After combine current time, the real first time is "
@@ -171,24 +177,32 @@
           // start, stop, getall and servercontrol need to check
           // if user is administor
           HttpSession sess = request.getSession(true);
+          SessionData sessionData = null;
           String sess_id = "";
           String username = "";
           String[] groupnames = {""};
-          Hashtable sessionHash = MetaCatServlet.getSessionHash();
+
           if (params.containsKey("sessionid")) 
           {
              sess_id = ((String[]) params.get("sessionid"))[0];
              logMetacat.info("in has sessionid "+ sess_id);
-             if (sessionHash.containsKey(sess_id)) 
+             if (SessionService.isSessionRegistered(sess_id)) 
              {
                   logMetacat.info("find the id " + sess_id + " in hash table");
-                  sess = (HttpSession) sessionHash.get(sess_id);
+                  sessionData = SessionService.getRegisteredSession(sess_id);
              }
            } 
-           username = (String) sess.getAttribute("username");
+          if (sessionData == null) {
+        	  sessionData = new SessionData(sess.getId(), 
+					(String) sess.getAttribute("username"), 
+					(String[]) sess.getAttribute("groups"),
+					(String) sess.getAttribute("password"));
+          }
+          
+           username = sessionData.getUserName();
            logMetacat.warn("The user name from session is: "+ username);
-           groupnames = (String[]) sess.getAttribute("groupnames");
-           if (!MetaCatUtil.isAdministrator(username, groupnames)) 
+           groupnames = sessionData.getGroupNames();
+           if (!LDAPUtil.isAdministrator(username, groupnames)) 
            {
                PrintWriter out = response.getWriter();
                out.print("<error>");
@@ -231,7 +245,7 @@
       replicationDaemon.cancel();
       replicationDaemon = new Timer(true);
       timedReplicationIsOn = false;
-      MetaCatUtil.setOption(TIMEREPLICATION, (new Boolean(timedReplicationIsOn)).toString());
+      PropertyService.setProperty(TIMEREPLICATION, (new Boolean(timedReplicationIsOn)).toString());
       out.println("Replication Handler Stopped");
       MetacatReplication.replLog("deltaT handler stopped");
 
@@ -278,11 +292,11 @@
       
       timedReplicationIsOn = true;
       // save settings to property file
-      MetaCatUtil.setOption(TIMEREPLICATION, (new Boolean(timedReplicationIsOn)).toString());
+      PropertyService.setProperty(TIMEREPLICATION, (new Boolean(timedReplicationIsOn)).toString());
       // note we couldn't use firstTime object because it has date info
       // we only need time info such as 10:00 PM
-      MetaCatUtil.setOption(FIRSTTIME, firstTimeStr);
-      MetaCatUtil.setOption(TIMEREPLICATIONINTERVAl, (new Long(timeInterval)).toString());
+      PropertyService.setProperty(FIRSTTIME, firstTimeStr);
+      PropertyService.setProperty(TIMEREPLICATIONINTERVAl, (new Long(timeInterval)).toString());
       replicationDaemon.cancel();
       replicationDaemon = new Timer(true);
       replicationDaemon.scheduleAtFixedRate(new ReplicationHandler(), firstTime,
@@ -511,70 +525,73 @@
 
   }
 
-  // download certificate with the public key from certURL and
-  // upload it onto this server; it then must be imported as a
-  // trusted certificate
-  private void downloadCertificate (String certURL)
-                throws FileNotFoundException, IOException, MalformedURLException
-  {
-    MetaCatUtil util = new MetaCatUtil();
-    String certPath = util.getOption("certPath"); //the path to be uploaded to
+   	// download certificate with the public key from certURL and
+	// upload it onto this server; it then must be imported as a
+	// trusted certificate
+	private void downloadCertificate(String certURL) throws FileNotFoundException,
+			IOException, MalformedURLException, PropertyNotFoundException {
+		
+		// the path to be uploaded to
+		String certPath = PropertyService.getProperty("application.tomcatDir")
+				+ "/webapps/" + PropertyService.getProperty("application.context"); 
 
-    // get filename from the URL of the certificate
-    String filename = certURL;
-    int slash = Math.max(filename.lastIndexOf('/'), filename.lastIndexOf('\\'));
-    if ( slash > -1 ) {
-      filename = filename.substring(slash + 1);
-    }
+		// get filename from the URL of the certificate
+		String filename = certURL;
+		int slash = Math.max(filename.lastIndexOf('/'), filename.lastIndexOf('\\'));
+		if (slash > -1) {
+			filename = filename.substring(slash + 1);
+		}
 
-    // open file output strem to write the input into it
-    File f = new File(certPath, filename);
-    synchronized (f) {
-      try {
-        if ( f.exists() ) {
-          throw new IOException("File already exist: " + f.getCanonicalFile());
-          //if ( f.exists() && !f.canWrite() ) {
-          //  throw new IOException("Not writable: " + f.getCanonicalFile());
-        }
-      } catch (SecurityException se) {
-        // if a security manager exists,
-        // its checkRead method is called for f.exist()
-        // or checkWrite method is called for f.canWrite()
-        throw se;
-      }
+		// open file output strem to write the input into it
+		File f = new File(certPath, filename);
+		synchronized (f) {
+			try {
+				if (f.exists()) {
+					throw new IOException("File already exist: " + f.getCanonicalFile());
+					// if ( f.exists() && !f.canWrite() ) {
+					// throw new IOException("Not writable: " +
+					// f.getCanonicalFile());
+				}
+			} catch (SecurityException se) {
+				// if a security manager exists,
+				// its checkRead method is called for f.exist()
+				// or checkWrite method is called for f.canWrite()
+				throw se;
+			}
 
-      // create a buffered byte output stream
-      // that uses a default-sized output buffer
-      FileOutputStream fos = new FileOutputStream(f);
-      BufferedOutputStream out = new BufferedOutputStream(fos);
+			// create a buffered byte output stream
+			// that uses a default-sized output buffer
+			FileOutputStream fos = new FileOutputStream(f);
+			BufferedOutputStream out = new BufferedOutputStream(fos);
 
-      // this should be http url
-      URL url = new URL(certURL);
-      BufferedInputStream bis = null;
-      try {
-        bis = new BufferedInputStream(url.openStream());
-        byte[] buf = new byte[4 * 1024]; // 4K buffer
-        int b = bis.read(buf);
-        while (b != -1) {
-          out.write(buf, 0, b);
-          b = bis.read(buf);
-        }
-      } finally {
-        if (bis != null) bis.close();
-      }
-      // the input and the output streams must be closed
-      bis.close();
-            out.flush();
-            out.close();
-            fos.close();
-    } // end of synchronized(f)
-  }
+			// this should be http url
+			URL url = new URL(certURL);
+			BufferedInputStream bis = null;
+			try {
+				bis = new BufferedInputStream(url.openStream());
+				byte[] buf = new byte[4 * 1024]; // 4K buffer
+				int b = bis.read(buf);
+				while (b != -1) {
+					out.write(buf, 0, b);
+					b = bis.read(buf);
+				}
+			} finally {
+				if (bis != null)
+					bis.close();
+			}
+			// the input and the output streams must be closed
+			bis.close();
+			out.flush();
+			out.close();
+			fos.close();
+		} // end of synchronized(f)
+	}
 
   /**
-   * when a forcereplication request comes in, local host sends a read request
-   * to the requesting server (remote server) for the specified docid.
-   * Then store it in local database.
-   */
+	 * when a forcereplication request comes in, local host sends a read request
+	 * to the requesting server (remote server) for the specified docid. Then
+	 * store it in local database.
+	 */
   private void handleForceReplicateRequest(PrintWriter out, Hashtable params,
                                            HttpServletResponse response, HttpServletRequest request)
   {
@@ -599,13 +616,13 @@
       logMetacat.info("Force replication action: "+dbaction);
       // sending back read request to remote server
       URL u = new URL("https://" + server + "?server="
-                +util.getLocalReplicationServerName()
+                +MetaCatUtil.getLocalReplicationServerName()
                 +"&action=read&docid=" + docid);
       String xmldoc = MetacatReplication.getURLContent(u);
 
       // get the document info from server
       URL docinfourl = new URL("https://" + server +
-                               "?server="+util.getLocalReplicationServerName()
+                               "?server="+MetaCatUtil.getLocalReplicationServerName()
                                +"&action=getdocumentinfo&docid=" + docid);
 
       String docInfoStr = MetacatReplication.getURLContent(docinfourl);
@@ -759,7 +776,7 @@
       logMetacat.info("Force replication action: "+dbaction);
       // get the document info from server
       URL docinfourl = new URL("https://" + server +
-                               "?server="+util.getLocalReplicationServerName()
+                               "?server="+MetaCatUtil.getLocalReplicationServerName()
                                +"&action=getdocumentinfo&docid=" + docid);
 
       String docInfoStr = MetacatReplication.getURLContent(docinfourl);
@@ -798,9 +815,9 @@
         //Get data file and store it into local file system.
         // sending back readdata request to server
         URL url = new URL("https://" + server + "?server="
-                +util.getLocalReplicationServerName()
+                +MetaCatUtil.getLocalReplicationServerName()
                 +"&action=readdata&docid=" + docid);
-        String datafilePath = util.getOption("datafilepath");
+        String datafilePath = PropertyService.getProperty("application.datafilepath");
         //register data file into xml_documents table and wite data file
         //into file system
         DocumentImpl.writeDataFileInReplication(url.openStream(), datafilePath,
@@ -941,7 +958,7 @@
 
   {
     // File path for data file
-    String filepath = util.getOption("datafilepath");
+    String filepath;
     // Request docid
     String docId = ((String[])(params.get("docid")))[0];
     //check if the doicd is null
@@ -955,9 +972,10 @@
     //in the key store, this is security issue
     try
     {
+      filepath = PropertyService.getProperty("application.datafilepath");
       String server = ((String[])params.get("server"))[0];
       URL u = new URL("https://" + server + "?server="
-                +util.getLocalReplicationServerName()
+                +MetaCatUtil.getLocalReplicationServerName()
                 +"&action=test");
       String test = MetacatReplication.getURLContent(u);
       //couldn't pass the test
@@ -1062,7 +1080,7 @@
       //in the key store, this is security issue
       String server = ((String[])params.get("server"))[0];
       URL u = new URL("https://" + server + "?server="
-                +util.getLocalReplicationServerName()
+                +MetaCatUtil.getLocalReplicationServerName()
                 +"&action=test");
       String test = MetacatReplication.getURLContent(u);
       //couldn't pass the test
@@ -1144,7 +1162,7 @@
       //try to open a https stream to test if the request server's public key
       //in the key store, this is security issue
       URL u = new URL("https://" + server + "?server="
-                +util.getLocalReplicationServerName()
+                +MetaCatUtil.getLocalReplicationServerName()
                 +"&action=test");
       String test = MetacatReplication.getURLContent(u);
       //couldn't pass the test
@@ -1180,8 +1198,8 @@
 
       // Append local server's name and replication servlet to doclist
       doclist.append("<?xml version=\"1.0\"?><replication>");
-      doclist.append("<server>").append(util.getLocalReplicationServerName());
-      //doclist.append(util.getOption("replicationpath"));
+      doclist.append("<server>").append(MetaCatUtil.getLocalReplicationServerName());
+      //doclist.append(util.getProperty("replicationpath"));
       doclist.append("</server><updates>");
 
       // Get correct docid that reside on this server according the requesting
@@ -1220,7 +1238,7 @@
       ResultSet rs = pstmt.getResultSet();
       boolean tablehasrows = rs.next();
       //If metacat configed to replicate data file
-      //if ((util.getOption("replicationsenddata")).equals("on"))
+      //if ((util.getProperty("replicationsenddata")).equals("on"))
       boolean replicateData = serverList.getDataReplicationValue(server);
       if (replicateData)
       {
@@ -1228,7 +1246,7 @@
         {
           String recordDoctype = rs.getString(3);
           Vector packagedoctypes = MetaCatUtil.getOptionList(
-                                     MetaCatUtil.getOption("packagedoctype"));
+                                     PropertyService.getProperty("packagedoctype"));
           //if this is a package file, put it at the end
           //because if a package file is read before all of the files it
           //refers to are loaded then there is an error
@@ -1253,7 +1271,7 @@
                 doclist.append("</docid><rev>").append(rs.getInt(2));
                 doclist.append("</rev>");
                 doclist.append("<datafile>");
-                doclist.append(MetaCatUtil.getOption("datafileflag"));
+                doclist.append(PropertyService.getProperty("datafileflag"));
                 doclist.append("</datafile>");
                 doclist.append("</updatedDocument>");
               }//else
@@ -1276,7 +1294,7 @@
           if(!recordDoctype.equals("BIN"))
           { //don't replicate data files
             Vector packagedoctypes = MetaCatUtil.getOptionList(
-                                     MetaCatUtil.getOption("packagedoctype"));
+                                     PropertyService.getProperty("packagedoctype"));
             if(recordDoctype != null && !packagedoctypes.contains(recordDoctype))
             {   //if this is a package file, put it at the end
               //because if a package file is read before all of the files it
@@ -1400,7 +1418,7 @@
             if (recordDoctype.equals("BIN"))
             {
                 revDocList.append("<datafile>");
-                revDocList.append(MetaCatUtil.getOption("datafileflag"));
+                revDocList.append(PropertyService.getProperty("datafileflag"));
                 revDocList.append("</datafile>");
             }
             revDocList.append("</revisionDocument>");
@@ -1459,7 +1477,12 @@
         sb.append("</entry_type><source_doctype>").append(rs.getString(2));
         sb.append("</source_doctype><target_doctype>").append(rs.getString(3));
         sb.append("</target_doctype><public_id>").append(rs.getString(4));
-        sb.append("</public_id><system_id>").append(rs.getString(5));
+        // system id may not have server url on front.  Add it if not.
+        String systemID = rs.getString(5);
+        if (!systemID.startsWith("http://")) {
+        	systemID = SystemUtil.getServerURL() + systemID;
+        }
+        sb.append("</public_id><system_id>").append(systemID);
         sb.append("</system_id></row>");
 
         tablehasrows = rs.next();
@@ -1674,7 +1697,6 @@
     Hashtable sl = new Hashtable();
     DBConnection dbConn = null;
     int serialNumber = -1;
-    //MetaCatUtil ut=new MetaCatUtil();
     docId=MetaCatUtil.getDocIdFromString(docId);
     PreparedStatement pstmt=null;
     int serverLocation;
@@ -1766,7 +1788,6 @@
     int serialNumber = -1;
     PreparedStatement pstmt = null;
     int serverCode = 1;
-    //MetaCatUtil ut = new MetaCatUtil();
     String docId=MetaCatUtil.getDocIdFromString(accNum);
 
     try
@@ -1855,42 +1876,39 @@
   }
 
   /**
-   * Method for writing replication messages to a log file specified in
-   * metacat.properties
-   */
-  public static void replLog(String message)
-  {
-    try
-    {
-      FileOutputStream fos = new FileOutputStream(
-                                 util.getOption("replicationlog"), true);
-      PrintWriter pw = new PrintWriter(fos);
-      SimpleDateFormat formatter = new SimpleDateFormat ("yy-MM-dd HH:mm:ss");
-      java.util.Date localtime = new java.util.Date();
-      String dateString = formatter.format(localtime);
-      dateString += " :: " + message;
-      //time stamp each entry
-      pw.println(dateString);
-      pw.flush();
-    }
-    catch(Exception e)
-    {
-      System.out.println("error writing to replication log from " +
-                         "MetacatReplication.replLog: " + e.getMessage());
-      //e.printStackTrace(System.out);
-    }
-  }
+	 * Method for writing replication messages to a log file specified in
+	 * metacat.properties
+	 */
+	public static void replLog(String message) {
+		try {
+			FileOutputStream fos = 
+				new FileOutputStream(PropertyService.getProperty("application.tomcatDir")
+					+ "/logs/metacatreplication.log", true);
+			PrintWriter pw = new PrintWriter(fos);
+			SimpleDateFormat formatter = new SimpleDateFormat("yy-MM-dd HH:mm:ss");
+			java.util.Date localtime = new java.util.Date();
+			String dateString = formatter.format(localtime);
+			dateString += " :: " + message;
+			// time stamp each entry
+			pw.println(dateString);
+			pw.flush();
+		} catch (Exception e) {
+			System.out.println("error writing to replication log from "
+					+ "MetacatReplication.replLog: " + e.getMessage());
+			// e.printStackTrace(System.out);
+		}
+	}
 
   /**
-   * Method for writing replication messages to a log file specified in
-   * metacat.properties
-   */
+	 * Method for writing replication messages to a log file specified in
+	 * metacat.properties
+	 */
   public static void replErrorLog(String message)
   {
     try
     {
       FileOutputStream fos = new FileOutputStream(
-                                 util.getOption("replicationerrorlog"), true);
+                                 PropertyService.getProperty("replicationerrorlog"), true);
       PrintWriter pw = new PrintWriter(fos);
       SimpleDateFormat formatter = new SimpleDateFormat ("yy-MM-dd HH:mm:ss");
       java.util.Date localtime = new java.util.Date();
Index: src/edu/ucsb/nceas/metacat/advancedsearch/Stylizer.java
===================================================================
--- src/edu/ucsb/nceas/metacat/advancedsearch/Stylizer.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/advancedsearch/Stylizer.java	(revision 4080)
@@ -34,7 +34,8 @@
 
 import org.apache.log4j.Logger;
 
-import edu.ucsb.nceas.metacat.MetaCatUtil;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 /**
  * @author dcosta
@@ -44,96 +45,80 @@
  */
 public class Stylizer {
 
-  private Logger logMetacat = Logger.getLogger(Stylizer.class);
-	
-  /**
-   * Applies the resultset.xsl stylesheet to the pathquery result string
-   * returned by Metacat.
-   * 
-   * @param resultset       the pathquery result string from Metacat
-   * @param sessionId       the user's session id
-   * @param metacatURL      the URL to the Metacat server
-   * @param qformat         The qformat (skin) to use when displaying results.
-   * @param xslPath         File path to the resultset.xsl stylesheet.
-   * 
-   * @return htmlString     the result of the transformation from XML to HTML
-   */
-  public String resultsetToHTML(final String resultset, 
-                                final String sessionId,
-                                final String metacatURL,
-                                final String qformat,
-                                final String xslPath) {
-    String htmlString = "";
-    Result result;
-    StringWriter stringWriter = new StringWriter();
-    Transformer transformer;
-    TransformerFactory transformerFactory;
-    Source xmlSource;
-    File xsltFile = new File(xslPath);            
-    Source xsltSource;
-    StringReader stringReader = new StringReader(resultset);
-    
-    xmlSource = new javax.xml.transform.stream.StreamSource(stringReader);
-    xsltSource = new javax.xml.transform.stream.StreamSource(xsltFile);
-    result = new javax.xml.transform.stream.StreamResult(stringWriter);
+	private Logger logMetacat = Logger.getLogger(Stylizer.class);
 
-    // create an instance of TransformerFactory
-    transformerFactory = TransformerFactory.newInstance();
+	/**
+	 * Applies the resultset.xsl stylesheet to the pathquery result string
+	 * returned by Metacat.
+	 * 
+	 * @param resultset       the pathquery result string from Metacat
+	 * @param sessionId       the user's session id
+	 * @param metacatURL      the URL to the Metacat server
+	 * @param qformat         The qformat (skin) to use when displaying results.
+	 * @param xslPath         File path to the resultset.xsl stylesheet.
+	 * 
+	 * @return htmlString     the result of the transformation from XML to HTML
+	 */
+	public String resultsetToHTML(final String resultset, final String sessionId,
+			final String metacatURL, final String qformat, final String xslPath) {
+		String htmlString = "";
+		Result result;
+		StringWriter stringWriter = new StringWriter();
+		Transformer transformer;
+		TransformerFactory transformerFactory;
+		Source xmlSource;
+		File xsltFile = new File(xslPath);
+		Source xsltSource;
+		StringReader stringReader = new StringReader(resultset);
 
-    try {
-      transformer = transformerFactory.newTransformer(xsltSource);
-      
-      MetaCatUtil metaCatUtil = new MetaCatUtil();
-      
-      String httpServer = MetaCatUtil.getOption("httpserver");
-      String context = MetaCatUtil.getOption("context");
-      
-      // Log error if httpserver or context are not set in metacat
-      // configuration, but allow transform to proceed.  User will
-      // see data, albeit without pretty formatting.
-      if (httpServer == null || context == null) {
-    	logMetacat.error("httpserver and context values must be set in " +
-    			"metacat configuration for advanced search formatting to " +
-    			"work properly");
-      } else {
-        transformer.setParameter("contextURL", httpServer+"/"+context+"/");
-      }
+		xmlSource = new javax.xml.transform.stream.StreamSource(stringReader);
+		xsltSource = new javax.xml.transform.stream.StreamSource(xsltFile);
+		result = new javax.xml.transform.stream.StreamResult(stringWriter);
 
-      if (sessionId != null) {
-        transformer.setParameter("sessid", sessionId);
-      }
+		// create an instance of TransformerFactory
+		transformerFactory = TransformerFactory.newInstance();
 
-      transformer.setParameter("metacatURL", metacatURL);
-      
-      if ((qformat != null) && (!qformat.equals(""))) {
-        transformer.setParameter("qformat", qformat);
-      }
-      
-      transformer.transform(xmlSource, result);
-      htmlString = stringWriter.toString();
-    }
-    catch (TransformerConfigurationException tce) {
-      // Error generated by the parser
-      Throwable x = tce;  // Use the contained exception, if any
-        
-      if (tce.getException() != null) {
-        x = tce.getException();    
-      }
+		try {
+			transformer = transformerFactory.newTransformer(xsltSource);
 
-      x.printStackTrace();   
-    }
-    catch (TransformerException te) {
-      // Error generated by the parser
-      Throwable x = te;  // Use the contained exception, if any
-        
-      if (te.getException() != null) {
-        x = te.getException();    
-      }
+			String contextURL = SystemUtil.getContextURL();
+			transformer.setParameter("contextURL", contextURL);
 
-      x.printStackTrace(); 
-    }
-      
-    return htmlString;
-  }
-  
+			if (sessionId != null) {
+				transformer.setParameter("sessid", sessionId);
+			}
+
+			transformer.setParameter("metacatURL", metacatURL);
+
+			if ((qformat != null) && (!qformat.equals(""))) {
+				transformer.setParameter("qformat", qformat);
+			}
+
+			transformer.transform(xmlSource, result);
+			htmlString = stringWriter.toString();
+		} catch (TransformerConfigurationException tce) {
+			// Error generated by the parser
+			Throwable x = tce; // Use the contained exception, if any
+
+			if (tce.getException() != null) {
+				x = tce.getException();
+			}
+
+			x.printStackTrace();
+		} catch (TransformerException te) {
+			// Error generated by the parser
+			Throwable x = te; // Use the contained exception, if any
+
+			if (te.getException() != null) {
+				x = te.getException();
+			}
+
+			x.printStackTrace();
+		} catch (PropertyNotFoundException pnfe) {
+			pnfe.printStackTrace();
+		}
+
+		return htmlString;
+	}
+
 }
\ No newline at end of file
Index: src/edu/ucsb/nceas/metacat/spatial/SpatialHarvester.java
===================================================================
--- src/edu/ucsb/nceas/metacat/spatial/SpatialHarvester.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/spatial/SpatialHarvester.java	(revision 4080)
@@ -31,8 +31,9 @@
 
 import org.apache.log4j.Logger;
 
-import edu.ucsb.nceas.metacat.MetaCatUtil;
 import edu.ucsb.nceas.metacat.DBConnection;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+
 import org.geotools.feature.Feature;
 
 /** 
